unit Unit1;

{$MODE Delphi}

interface

uses
  Lcltype, Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons, Grids, Menus, ChessBrd;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    backbutton: TButton;
    forwardbutton: TButton;
    Button4: TButton;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    ML: TStringGrid;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure backbuttonClick(Sender: TObject);
    procedure forwardbuttonClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MLDrawCell(Sender: TObject; aCol, aRow: Integer; aRect: TRect; aState: TGridDrawState);
    procedure MLKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MLMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
    procedure CreateChessBoard;
    procedure Update_MoveList;
    procedure Update_Movelist_Selection;
    procedure ChessBoardLegalMove(Sender: TObject; oldSq, newSq: Square);
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  CB: TChessBrd;
  Board_Created: boolean = False;

implementation

{$R *.lfm}

function copy_to_end(source: string; start: integer): string;
begin
 Result:=copy(source, start, length(source)-start+1);
end;

procedure Clear_Movelist;
var i: integer;
begin
 for i:=0 to form1.ML.rowcount-1 do
  form1.ML.rows[i].Clear;
end;

procedure TForm1.Update_MoveList;
var
 MoveList: TStringList;
 tmp: string;
 p, i, count: integer;
begin
 Clear_Movelist;
 MoveList:=TStringList.Create;
 CB.GetMoveList(MoveList);
 count:=MoveList.count;
 if count>0 then ML.rowcount:=count else ML.rowcount:=1;
 for i:=0 to count-1 do
 begin
  tmp:=movelist.strings[i];
  p:=pos('.', tmp);
  ML.Cells[0,i]:=copy(tmp, 1, p);
  tmp:=copy_to_end(tmp, p+1);
  p:=pos(',', tmp);
  if p>0 then
  begin
   ML.Cells[1,i]:=copy(tmp, 1, p-1);
   ML.Cells[2,i]:=copy_to_end(tmp, p+1);
   ML.col:=2;
  end else
  begin
   ML.Cells[1,i]:=tmp;
   ML.Cells[2,i]:='';
   ML.col:=1;
  end;
 end;
 ML.SetFocus;
 ML.Row:=ML.RowCount-1;
 MoveList.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 CB.ComputerPlaysWhite:=false;
 CB.newgame;
 Update_MoveList;
 CB.ComputerPlaysBlack:=true;
end;

procedure TForm1.ChessBoardLegalMove(Sender: TObject; oldSq, newSq: Square);
begin
 Update_MoveList;
end;

procedure TForm1.CreateChessBoard;
begin
 CB:=TChessBrd.Create(Form1);
 CB.Left:=0;
 CB.Top:=0;
 CB.Parent:=Form1;
 //CB.Language:=cblEnglish;
 //CB.Notation:=cblcomplete;
 CB.Animatemoves:=false;
 CB.SearchDepth:=4;
 CB.CustomEngine:=false;
 CB.ComputerPlaysBlack:=true;
 CB.PromotionPiece:=cblAsk;
 CB.BorderColor:=clGray;
 CB.SquareColorDark:=clGray;
 CB.SquareColorLight:=clSilver;
 CB.OnLegalMove:=ChessBoardLegalMove;
 CB.DisplayCoords:=[North, East, West, South];
end;

procedure TForm1.MLKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 if key=vk_left then backbuttonclick(self);
 if key=vk_right then forwardbuttonclick(self);
 if (key=vk_up) or (key=vk_down) then
   if ML.col=2 then CB.GotoMove(ML.Row+2, true) else CB.GotoMove(ML.Row+1, false);
end;

procedure TForm1.MLMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if ML.col=2 then CB.GotoMove(ML.Row+2, true) else CB.GotoMove(ML.Row+1, false);
end;

procedure TForm1.Update_Movelist_Selection;
var x, y: integer;
begin
 if CB.WhiteToMove then
 begin
  x:=2;
  y:=CB.currentmove-2;
 end
 else
 begin
  x:=1;
  y:=CB.currentmove-1;
 end;
 if y<0 then begin y:=0; x:=0; end;
 ML.col:=x;
 ML.row:=y;
end;

procedure TForm1.backbuttonClick(Sender: TObject);
begin
 CB.MoveBackward;
 Update_MoveList;
 Update_Movelist_Selection;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 if Board_Created=false then
 begin
  CreateChessBoard;
  Board_Created:=true;
 end;
end;

procedure TForm1.forwardbuttonClick(Sender: TObject);
begin
 CB.MoveForward;
 Update_MoveList;
 Update_Movelist_Selection;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 if CB.ComputerplaysWhite then
 begin
  CB.ComputerPlaysWhite:=false;
  CB.ComputerPlaysBlack:=true;
 end else
 if CB.ComputerplaysBlack then
 begin
  CB.ComputerPlaysBlack:=false;
  CB.ComputerPlaysWhite:=true;
 end;
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  cb.computerplayswhite:=false;
  cb.computerplaysblack:=false;
  if opendialog1.execute then cb.LoadPgn(opendialog1.filename, 1);
end;

procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  if savedialog1.execute then
  begin
   if fileexists(savedialog1.filename) then
    if messageDlg(Format('File exists!'+#13#13+ 'Overwrite %s', [savedialog1.filename]), mtConfirmation, mbYesNoCancel, 0)<>idYes then exit;
   cb.SavePgn(savedialog1.filename);
  end;
end;

procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.MLDrawCell(Sender: TObject; aCol, aRow: Integer; aRect: TRect; aState: TGridDrawState);
begin
 if (aRow=ML.Row) and (aCol=ML.Col) and (aCol>0) then
 begin
  ML.Canvas.Brush.Color:=Clskyblue;
  ML.Canvas.FillRect(aRect);
  ML.Canvas.Textout(aRect.Left+2, aRect.Top+2, ML.Cells[aCol, aRow])
 end;
end;

end.
